stages:
  - build
  - test
  - deploy
  - qa

code_quality:
  retry: 2
  stage: test
  allow_failure: true
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
  services:
    - docker:stable-dind
  script:
    - docker run
        --env SOURCE_CODE="$PWD"
        --volume "$PWD":/code
        --volume /var/run/docker.sock:/var/run/docker.sock 
        "registry.gitlab.com/gitlab-org/ci-cd/codequality:0.85.10" /code
  artifacts:
    paths: [gl-code-quality-report.json]
    expire_in: 3 weeks

rspec:
  image: ruby:2.7.1
  stage: test
  variables:
    POSTGRES_DB: active_record_api_rest_controller_test
    POSTGRES_USER: postgres
    POSTGRES_PASSWORD: postgres
    POSTGRES_HOST_AUTH_METHOD: trust
    RAILS_ENV: test
  services:
  - docker:dind
  - postgres:alpine
  before_script:
    - bundle install --quiet
    - cd spec/dummy && RAILS_ENV=test bundle exec rake db:create db:schema:load && cd ../../
  script:
    - bundle exec rspec
  artifacts:
    name: "$CI_COMMIT_REF_NAME-$CI_COMMIT_SHA"
    when: always
    expire_in: 1 week
    paths:
      - coverage/

codequality-verify:
  retry: 2
  stage: qa
  allow_failure: true
  image: ruby:2.7.1
  script:
    - ruby -r json -r yaml -e "puts JSON.parse(File.open('gl-code-quality-report.json', 'r', &:read)).to_yaml"
    - "! grep fingerprint gl-code-quality-report.json > /dev/null 2>&1"

release:
  stage: deploy
  image: ruby:2.7.1
  before_script:
    - git config --global user.email dev@fullmeasureed.com
    - git config --global user.name fme-ci
    - git remote remove origin
    - git remote add origin https://fme-ci:${GITLAB_CI_TOKEN}@gitlab.com/$CI_PROJECT_PATH.git
    - git fetch origin master
    - git checkout master
    - git branch -u origin/master
    - gem install gem-release
  script:
    - "echo -e \"---\n:rubygems_api_key: ${RUBYGEMS_KEY}\" > ~/.gem/credentials"
    - chmod 0600 ~/.gem/credentials
    - gem bump patch --skip-ci --tag --push --release
  only:
    - /(^master$)/
